Index: lemon/lgf_writer.h
===================================================================
--- lemon/lgf_writer.h	(revision 327)
+++ lemon/lgf_writer.h	(revision 220)
@@ -19,5 +19,5 @@
 ///\ingroup lemon_io
 ///\file
-///\brief \ref lgf-format "LEMON Graph Format" writer.
+///\brief \ref lgf-format "Lemon Graph Format" writer.
 
 
@@ -34,9 +34,7 @@
 #include <functional>
 
+#include <lemon/assert.h>
 #include <lemon/core.h>
 #include <lemon/maps.h>
-
-#include <lemon/concept_check.h>
-#include <lemon/concepts/maps.h>
 
 namespace lemon {
@@ -55,5 +53,5 @@
     template <typename T>
     bool operator<(const T&, const T&) {
-      throw FormatError("Label map is not comparable");
+      throw DataFormatError("Label map is not comparable");
     }
 
@@ -203,5 +201,5 @@
           _map.find(str);
         if (it == _map.end()) {
-          throw FormatError("Item not found");
+          throw DataFormatError("Item not found");
         }
         return it->second;
@@ -223,5 +221,5 @@
           ::const_iterator it = _map.find(val);
         if (it == _map.end()) {
-          throw FormatError("Item not found");
+          throw DataFormatError("Item not found");
         }
         return (_graph.direction(val) ? '+' : '-') + it->second;
@@ -307,43 +305,4 @@
     }
 
-    class Section {
-    public:
-      virtual ~Section() {}
-      virtual void process(std::ostream& os) = 0;
-    };
-
-    template <typename Functor>
-    class LineSection : public Section {
-    private:
-
-      Functor _functor;
-
-    public:
-
-      LineSection(const Functor& functor) : _functor(functor) {}
-      virtual ~LineSection() {}
-
-      virtual void process(std::ostream& os) {
-        std::string line;
-        while (!(line = _functor()).empty()) os << line << std::endl;
-      }
-    };
-
-    template <typename Functor>
-    class StreamSection : public Section {
-    private:
-
-      Functor _functor;
-
-    public:
-
-      StreamSection(const Functor& functor) : _functor(functor) {}
-      virtual ~StreamSection() {}
-
-      virtual void process(std::ostream& os) {
-        _functor(os);
-      }
-    };
-
   }
 
@@ -351,36 +310,15 @@
   class DigraphWriter;
 
-  /// \brief Return a \ref DigraphWriter class
-  ///
-  /// This function just returns a \ref DigraphWriter class.
-  /// \relates DigraphWriter
   template <typename Digraph>
-  DigraphWriter<Digraph> digraphWriter(const Digraph& digraph,
-                                       std::ostream& os = std::cout) {
-    DigraphWriter<Digraph> tmp(digraph, os);
-    return tmp;
-  }
-
-  /// \brief Return a \ref DigraphWriter class
-  ///
-  /// This function just returns a \ref DigraphWriter class.
-  /// \relates DigraphWriter
+  DigraphWriter<Digraph> digraphWriter(std::ostream& os,
+                                       const Digraph& digraph);
+
   template <typename Digraph>
-  DigraphWriter<Digraph> digraphWriter(const Digraph& digraph,
-                                       const std::string& fn) {
-    DigraphWriter<Digraph> tmp(digraph, fn);
-    return tmp;
-  }
-
-  /// \brief Return a \ref DigraphWriter class
-  ///
-  /// This function just returns a \ref DigraphWriter class.
-  /// \relates DigraphWriter
+  DigraphWriter<Digraph> digraphWriter(const std::string& fn,
+                                       const Digraph& digraph);
+
   template <typename Digraph>
-  DigraphWriter<Digraph> digraphWriter(const Digraph& digraph,
-                                       const char* fn) {
-    DigraphWriter<Digraph> tmp(digraph, fn);
-    return tmp;
-  }
+  DigraphWriter<Digraph> digraphWriter(const char *fn,
+                                       const Digraph& digraph);
 
   /// \ingroup lemon_io
@@ -403,5 +341,5 @@
   ///
   ///\code
-  /// DigraphWriter<Digraph>(digraph, std::cout).
+  /// DigraphWriter<Digraph>(std::cout, digraph).
   ///   nodeMap("coordinates", coord_map).
   ///   nodeMap("size", size).
@@ -473,6 +411,6 @@
     /// Construct a directed graph writer, which writes to the given
     /// output stream.
-    DigraphWriter(const Digraph& digraph, std::ostream& os = std::cout)
-      : _os(&os), local_os(false), _digraph(digraph),
+    DigraphWriter(std::ostream& is, const Digraph& digraph)
+      : _os(&is), local_os(false), _digraph(digraph),
         _skip_nodes(false), _skip_arcs(false) {}
 
@@ -481,12 +419,7 @@
     /// Construct a directed graph writer, which writes to the given
     /// output file.
-    DigraphWriter(const Digraph& digraph, const std::string& fn)
+    DigraphWriter(const std::string& fn, const Digraph& digraph)
       : _os(new std::ofstream(fn.c_str())), local_os(true), _digraph(digraph),
-        _skip_nodes(false), _skip_arcs(false) {
-      if (!(*_os)) {
-        delete _os;
-        throw IoError("Cannot write file", fn);
-      }
-    }
+        _skip_nodes(false), _skip_arcs(false) {}
 
     /// \brief Constructor
@@ -494,12 +427,7 @@
     /// Construct a directed graph writer, which writes to the given
     /// output file.
-    DigraphWriter(const Digraph& digraph, const char* fn)
+    DigraphWriter(const char* fn, const Digraph& digraph)
       : _os(new std::ofstream(fn)), local_os(true), _digraph(digraph),
-        _skip_nodes(false), _skip_arcs(false) {
-      if (!(*_os)) {
-        delete _os;
-        throw IoError("Cannot write file", fn);
-      }
-    }
+        _skip_nodes(false), _skip_arcs(false) {}
 
     /// \brief Destructor
@@ -527,10 +455,10 @@
   private:
 
-    friend DigraphWriter<Digraph> digraphWriter<>(const Digraph& digraph,
-                                                  std::ostream& os);
-    friend DigraphWriter<Digraph> digraphWriter<>(const Digraph& digraph,
-                                                  const std::string& fn);
-    friend DigraphWriter<Digraph> digraphWriter<>(const Digraph& digraph,
-                                                  const char *fn);
+    friend DigraphWriter<Digraph> digraphWriter<>(std::ostream& os,
+                                                  const Digraph& digraph);
+    friend DigraphWriter<Digraph> digraphWriter<>(const std::string& fn,
+                                                  const Digraph& digraph);
+    friend DigraphWriter<Digraph> digraphWriter<>(const char *fn,
+                                                  const Digraph& digraph);
 
     DigraphWriter(DigraphWriter& other)
@@ -934,37 +862,48 @@
   };
 
+  /// \brief Return a \ref DigraphWriter class
+  ///
+  /// This function just returns a \ref DigraphWriter class.
+  /// \relates DigraphWriter
+  template <typename Digraph>
+  DigraphWriter<Digraph> digraphWriter(std::ostream& os,
+                                       const Digraph& digraph) {
+    DigraphWriter<Digraph> tmp(os, digraph);
+    return tmp;
+  }
+
+  /// \brief Return a \ref DigraphWriter class
+  ///
+  /// This function just returns a \ref DigraphWriter class.
+  /// \relates DigraphWriter
+  template <typename Digraph>
+  DigraphWriter<Digraph> digraphWriter(const std::string& fn,
+                                       const Digraph& digraph) {
+    DigraphWriter<Digraph> tmp(fn, digraph);
+    return tmp;
+  }
+
+  /// \brief Return a \ref DigraphWriter class
+  ///
+  /// This function just returns a \ref DigraphWriter class.
+  /// \relates DigraphWriter
+  template <typename Digraph>
+  DigraphWriter<Digraph> digraphWriter(const char* fn,
+                                       const Digraph& digraph) {
+    DigraphWriter<Digraph> tmp(fn, digraph);
+    return tmp;
+  }
+
   template <typename Graph>
   class GraphWriter;
 
-  /// \brief Return a \ref GraphWriter class
-  ///
-  /// This function just returns a \ref GraphWriter class.
-  /// \relates GraphWriter
   template <typename Graph>
-  GraphWriter<Graph> graphWriter(const Graph& graph,
-                                 std::ostream& os = std::cout) {
-    GraphWriter<Graph> tmp(graph, os);
-    return tmp;
-  }
-
-  /// \brief Return a \ref GraphWriter class
-  ///
-  /// This function just returns a \ref GraphWriter class.
-  /// \relates GraphWriter
+  GraphWriter<Graph> graphWriter(std::ostream& os, const Graph& graph);
+
   template <typename Graph>
-  GraphWriter<Graph> graphWriter(const Graph& graph, const std::string& fn) {
-    GraphWriter<Graph> tmp(graph, fn);
-    return tmp;
-  }
-
-  /// \brief Return a \ref GraphWriter class
-  ///
-  /// This function just returns a \ref GraphWriter class.
-  /// \relates GraphWriter
+  GraphWriter<Graph> graphWriter(const std::string& fn, const Graph& graph);
+
   template <typename Graph>
-  GraphWriter<Graph> graphWriter(const Graph& graph, const char* fn) {
-    GraphWriter<Graph> tmp(graph, fn);
-    return tmp;
-  }
+  GraphWriter<Graph> graphWriter(const char *fn, const Graph& graph);
 
   /// \ingroup lemon_io
@@ -996,5 +935,5 @@
     bool local_os;
 
-    const Graph& _graph;
+    Graph& _graph;
 
     std::string _nodes_caption;
@@ -1028,6 +967,6 @@
     /// Construct a directed graph writer, which writes to the given
     /// output stream.
-    GraphWriter(const Graph& graph, std::ostream& os = std::cout)
-      : _os(&os), local_os(false), _graph(graph),
+    GraphWriter(std::ostream& is, const Graph& graph)
+      : _os(&is), local_os(false), _graph(graph),
         _skip_nodes(false), _skip_edges(false) {}
 
@@ -1036,12 +975,7 @@
     /// Construct a directed graph writer, which writes to the given
     /// output file.
-    GraphWriter(const Graph& graph, const std::string& fn)
+    GraphWriter(const std::string& fn, const Graph& graph)
       : _os(new std::ofstream(fn.c_str())), local_os(true), _graph(graph),
-        _skip_nodes(false), _skip_edges(false) {
-      if (!(*_os)) {
-        delete _os;
-        throw IoError("Cannot write file", fn);
-      }
-    }
+        _skip_nodes(false), _skip_edges(false) {}
 
     /// \brief Constructor
@@ -1049,12 +983,7 @@
     /// Construct a directed graph writer, which writes to the given
     /// output file.
-    GraphWriter(const Graph& graph, const char* fn)
+    GraphWriter(const char* fn, const Graph& graph)
       : _os(new std::ofstream(fn)), local_os(true), _graph(graph),
-        _skip_nodes(false), _skip_edges(false) {
-      if (!(*_os)) {
-        delete _os;
-        throw IoError("Cannot write file", fn);
-      }
-    }
+        _skip_nodes(false), _skip_edges(false) {}
 
     /// \brief Destructor
@@ -1082,10 +1011,10 @@
   private:
 
-    friend GraphWriter<Graph> graphWriter<>(const Graph& graph,
-                                            std::ostream& os);
-    friend GraphWriter<Graph> graphWriter<>(const Graph& graph,
-                                            const std::string& fn);
-    friend GraphWriter<Graph> graphWriter<>(const Graph& graph,
-                                            const char *fn);
+    friend GraphWriter<Graph> graphWriter<>(std::ostream& os,
+                                            const Graph& graph);
+    friend GraphWriter<Graph> graphWriter<>(const std::string& fn,
+                                            const Graph& graph);
+    friend GraphWriter<Graph> graphWriter<>(const char *fn,
+                                            const Graph& graph);
 
     GraphWriter(GraphWriter& other)
@@ -1535,214 +1464,31 @@
   };
 
-  class SectionWriter;
-
-  SectionWriter sectionWriter(std::istream& is);
-  SectionWriter sectionWriter(const std::string& fn);
-  SectionWriter sectionWriter(const char* fn);
-
-  /// \ingroup lemon_io
-  ///
-  /// \brief Section writer class
-  ///
-  /// In the \ref lgf-format "LGF" file extra sections can be placed,
-  /// which contain any data in arbitrary format. Such sections can be
-  /// written with this class. A writing rule can be added to the
-  /// class with two different functions. With the \c sectionLines()
-  /// function a generator can write the section line-by-line, while
-  /// with the \c sectionStream() member the section can be written to
-  /// an output stream.
-  class SectionWriter {
-  private:
-
-    std::ostream* _os;
-    bool local_os;
-
-    typedef std::vector<std::pair<std::string, _writer_bits::Section*> >
-    Sections;
-
-    Sections _sections;
-
-  public:
-
-    /// \brief Constructor
-    ///
-    /// Construct a section writer, which writes to the given output
-    /// stream.
-    SectionWriter(std::ostream& os)
-      : _os(&os), local_os(false) {}
-
-    /// \brief Constructor
-    ///
-    /// Construct a section writer, which writes into the given file.
-    SectionWriter(const std::string& fn)
-      : _os(new std::ofstream(fn.c_str())), local_os(true) {
-      if (!(*_os)) {
-        delete _os;
-        throw IoError("Cannot write file", fn);
-      }
-    }
-
-    /// \brief Constructor
-    ///
-    /// Construct a section writer, which writes into the given file.
-    SectionWriter(const char* fn)
-      : _os(new std::ofstream(fn)), local_os(true) {
-      if (!(*_os)) {
-        delete _os;
-        throw IoError("Cannot write file", fn);
-      }
-    }
-
-    /// \brief Destructor
-    ~SectionWriter() {
-      for (Sections::iterator it = _sections.begin();
-           it != _sections.end(); ++it) {
-        delete it->second;
-      }
-
-      if (local_os) {
-        delete _os;
-      }
-
-    }
-
-  private:
-
-    friend SectionWriter sectionWriter(std::ostream& os);
-    friend SectionWriter sectionWriter(const std::string& fn);
-    friend SectionWriter sectionWriter(const char* fn);
-
-    SectionWriter(SectionWriter& other)
-      : _os(other._os), local_os(other.local_os) {
-
-      other._os = 0;
-      other.local_os = false;
-
-      _sections.swap(other._sections);
-    }
-
-    SectionWriter& operator=(const SectionWriter&);
-
-  public:
-
-    /// \name Section writers
-    /// @{
-
-    /// \brief Add a section writer with line oriented writing
-    ///
-    /// The first parameter is the type descriptor of the section, the
-    /// second is a generator with std::string values. At the writing
-    /// process, the returned \c std::string will be written into the
-    /// output file until it is an empty string.
-    ///
-    /// For example, an integer vector is written into a section.
-    ///\code
-    ///  @numbers
-    ///  12 45 23 78
-    ///  4 28 38 28
-    ///  23 6 16
-    ///\endcode
-    ///
-    /// The generator is implemented as a struct.
-    ///\code
-    ///  struct NumberSection {
-    ///    std::vector<int>::const_iterator _it, _end;
-    ///    NumberSection(const std::vector<int>& data)
-    ///      : _it(data.begin()), _end(data.end()) {}
-    ///    std::string operator()() {
-    ///      int rem_in_line = 4;
-    ///      std::ostringstream ls;
-    ///      while (rem_in_line > 0 && _it != _end) {
-    ///        ls << *(_it++) << ' ';
-    ///        --rem_in_line;
-    ///      }
-    ///      return ls.str();
-    ///    }
-    ///  };
-    ///
-    ///  // ...
-    ///
-    ///  writer.sectionLines("numbers", NumberSection(vec));
-    ///\endcode
-    template <typename Functor>
-    SectionWriter& sectionLines(const std::string& type, Functor functor) {
-      LEMON_ASSERT(!type.empty(), "Type is empty.");
-      _sections.push_back(std::make_pair(type,
-        new _writer_bits::LineSection<Functor>(functor)));
-      return *this;
-    }
-
-
-    /// \brief Add a section writer with stream oriented writing
-    ///
-    /// The first parameter is the type of the section, the second is
-    /// a functor, which takes a \c std::ostream& parameter. The
-    /// functor writes the section to the output stream.
-    /// \warning The last line must be closed with end-line character.
-    template <typename Functor>
-    SectionWriter& sectionStream(const std::string& type, Functor functor) {
-      LEMON_ASSERT(!type.empty(), "Type is empty.");
-      _sections.push_back(std::make_pair(type,
-         new _writer_bits::StreamSection<Functor>(functor)));
-      return *this;
-    }
-
-    /// @}
-
-  public:
-
-
-    /// \name Execution of the writer
-    /// @{
-
-    /// \brief Start the batch processing
-    ///
-    /// This function starts the batch processing.
-    void run() {
-
-      LEMON_ASSERT(_os != 0, "This writer is assigned to an other writer");
-
-      for (Sections::iterator it = _sections.begin();
-           it != _sections.end(); ++it) {
-        (*_os) << '@' << it->first << std::endl;
-        it->second->process(*_os);
-      }
-    }
-
-    /// \brief Give back the stream of the writer
-    ///
-    /// Returns the stream of the writer
-    std::ostream& ostream() {
-      return *_os;
-    }
-
-    /// @}
-
-  };
-
-  /// \brief Return a \ref SectionWriter class
-  ///
-  /// This function just returns a \ref SectionWriter class.
-  /// \relates SectionWriter
-  inline SectionWriter sectionWriter(std::ostream& os) {
-    SectionWriter tmp(os);
+  /// \brief Return a \ref GraphWriter class
+  ///
+  /// This function just returns a \ref GraphWriter class.
+  /// \relates GraphWriter
+  template <typename Graph>
+  GraphWriter<Graph> graphWriter(std::ostream& os, const Graph& graph) {
+    GraphWriter<Graph> tmp(os, graph);
     return tmp;
   }
 
-  /// \brief Return a \ref SectionWriter class
-  ///
-  /// This function just returns a \ref SectionWriter class.
-  /// \relates SectionWriter
-  inline SectionWriter sectionWriter(const std::string& fn) {
-    SectionWriter tmp(fn);
+  /// \brief Return a \ref GraphWriter class
+  ///
+  /// This function just returns a \ref GraphWriter class.
+  /// \relates GraphWriter
+  template <typename Graph>
+  GraphWriter<Graph> graphWriter(const std::string& fn, const Graph& graph) {
+    GraphWriter<Graph> tmp(fn, graph);
     return tmp;
   }
 
-  /// \brief Return a \ref SectionWriter class
-  ///
-  /// This function just returns a \ref SectionWriter class.
-  /// \relates SectionWriter
-  inline SectionWriter sectionWriter(const char* fn) {
-    SectionWriter tmp(fn);
+  /// \brief Return a \ref GraphWriter class
+  ///
+  /// This function just returns a \ref GraphWriter class.
+  /// \relates GraphWriter
+  template <typename Graph>
+  GraphWriter<Graph> graphWriter(const char* fn, const Graph& graph) {
+    GraphWriter<Graph> tmp(fn, graph);
     return tmp;
   }
Index: lemon/list_graph.h
===================================================================
--- lemon/list_graph.h	(revision 317)
+++ lemon/list_graph.h	(revision 220)
@@ -364,16 +364,4 @@
     }
 
-    ///\brief Erase a node from the digraph.
-    ///
-    ///Erase a node from the digraph.
-    ///
-    void erase(const Node& n) { Parent::erase(n); }
-
-    ///\brief Erase an arc from the digraph.
-    ///
-    ///Erase an arc from the digraph.
-    ///
-    void erase(const Arc& a) { Parent::erase(a); }
-
     /// Node validity check
 
@@ -396,7 +384,7 @@
     bool valid(Arc a) const { return Parent::valid(a); }
 
-    /// Change the target of \c a to \c n
-
-    /// Change the target of \c a to \c n
+    /// Change the target of \c e to \c n
+
+    /// Change the target of \c e to \c n
     ///
     ///\note The <tt>ArcIt</tt>s and <tt>OutArcIt</tt>s referencing
@@ -406,19 +394,19 @@
     ///\warning This functionality cannot be used together with the Snapshot
     ///feature.
-    void changeTarget(Arc a, Node n) {
-      Parent::changeTarget(a,n);
-    }
-    /// Change the source of \c a to \c n
-
-    /// Change the source of \c a to \c n
-    ///
-    ///\note The <tt>InArcIt</tt>s referencing the changed arc remain
-    ///valid. However the <tt>ArcIt</tt>s and <tt>OutArcIt</tt>s are
+    void changeTarget(Arc e, Node n) {
+      Parent::changeTarget(e,n);
+    }
+    /// Change the source of \c e to \c n
+
+    /// Change the source of \c e to \c n
+    ///
+    ///\note The <tt>ArcIt</tt>s and <tt>InArcIt</tt>s referencing
+    ///the changed arc remain valid. However <tt>OutArcIt</tt>s are
     ///invalidated.
     ///
     ///\warning This functionality cannot be used together with the Snapshot
     ///feature.
-    void changeSource(Arc a, Node n) {
-      Parent::changeSource(a,n);
+    void changeSource(Arc e, Node n) {
+      Parent::changeSource(e,n);
     }
 
@@ -502,6 +490,8 @@
     ///be invalidated.
     ///
-    ///\warning This functionality cannot be used in conjunction with the
+    ///\warning This functionality cannot be used together with the
     ///Snapshot feature.
+    ///
+    ///\todo It could be implemented in a bit faster way.
     Node split(Node n, bool connect = true) {
       Node b = addNode();
@@ -841,7 +831,5 @@
 
     public:
-      operator Edge() const { 
-        return id != -1 ? edgeFromId(id / 2) : INVALID; 
-      }
+      operator Edge() const { return edgeFromId(id / 2); }
 
       Arc() {}
@@ -1115,5 +1103,5 @@
   protected:
 
-    void changeV(Edge e, Node n) {
+    void changeTarget(Edge e, Node n) {
       if(arcs[2 * e.id].next_out != -1) {
         arcs[arcs[2 * e.id].next_out].prev_out = arcs[2 * e.id].prev_out;
@@ -1136,5 +1124,5 @@
     }
 
-    void changeU(Edge e, Node n) {
+    void changeSource(Edge e, Node n) {
       if(arcs[(2 * e.id) | 1].next_out != -1) {
         arcs[arcs[(2 * e.id) | 1].next_out].prev_out =
@@ -1220,16 +1208,4 @@
       return Parent::addEdge(s, t);
     }
-
-    /// \brief Erase a node from the graph.
-    ///
-    /// Erase a node from the graph.
-    ///
-    void erase(const Node& n) { Parent::erase(n); }
-
-    /// \brief Erase an edge from the graph.
-    ///
-    /// Erase an edge from the graph.
-    ///
-    void erase(const Edge& e) { Parent::erase(e); }
     /// Node validity check
 
@@ -1259,30 +1235,64 @@
     /// added to the graph.
     bool valid(Edge e) const { return Parent::valid(e); }
-    /// \brief Change the end \c u of \c e to \c n
-    ///
-    /// This function changes the end \c u of \c e to node \c n.
-    ///
-    ///\note The <tt>EdgeIt</tt>s and <tt>ArcIt</tt>s referencing the
-    ///changed edge are invalidated and if the changed node is the
-    ///base node of an iterator then this iterator is also
-    ///invalidated.
+    /// \brief Change the source of \c e to \c n
+    ///
+    /// This function changes the source of \c e to \c n.
+    ///
+    ///\note The <tt>ArcIt</tt>s and <tt>InArcIt</tt>s
+    ///referencing the changed arc remain
+    ///valid. However <tt>OutArcIt</tt>s are invalidated.
     ///
     ///\warning This functionality cannot be used together with the
     ///Snapshot feature.
-    void changeU(Edge e, Node n) {
-      Parent::changeU(e,n);
-    }
-    /// \brief Change the end \c v of \c e to \c n
-    ///
-    /// This function changes the end \c v of \c e to \c n.
-    ///
-    ///\note The <tt>EdgeIt</tt>s referencing the changed edge remain
-    ///valid, however <tt>ArcIt</tt>s and if the changed node is the
-    ///base node of an iterator then this iterator is invalidated.
+    void changeSource(Edge e, Node n) {
+      Parent::changeSource(e,n);
+    }
+    /// \brief Change the target of \c e to \c n
+    ///
+    /// This function changes the target of \c e to \c n.
+    ///
+    /// \note The <tt>ArcIt</tt>s referencing the changed arc remain
+    /// valid. However the other iterators may be invalidated.
     ///
     ///\warning This functionality cannot be used together with the
     ///Snapshot feature.
-    void changeV(Edge e, Node n) {
-      Parent::changeV(e,n);
+    void changeTarget(Edge e, Node n) {
+      Parent::changeTarget(e,n);
+    }
+    /// \brief Change the source of \c e to \c n
+    ///
+    /// This function changes the source of \c e to \c n.
+    /// It also changes the proper node of the represented edge.
+    ///
+    ///\note The <tt>ArcIt</tt>s and <tt>InArcIt</tt>s
+    ///referencing the changed arc remain
+    ///valid. However <tt>OutArcIt</tt>s are invalidated.
+    ///
+    ///\warning This functionality cannot be used together with the
+    ///Snapshot feature.
+    void changeSource(Arc e, Node n) {
+      if (Parent::direction(e)) {
+        Parent::changeSource(e,n);
+      } else {
+        Parent::changeTarget(e,n);
+      }
+    }
+    /// \brief Change the target of \c e to \c n
+    ///
+    /// This function changes the target of \c e to \c n.
+    /// It also changes the proper node of the represented edge.
+    ///
+    ///\note The <tt>ArcIt</tt>s and <tt>OutArcIt</tt>s
+    ///referencing the changed arc remain
+    ///valid. However <tt>InArcIt</tt>s are invalidated.
+    ///
+    ///\warning This functionality cannot be used together with the
+    ///Snapshot feature.
+    void changeTarget(Arc e, Node n) {
+      if (Parent::direction(e)) {
+        Parent::changeTarget(e,n);
+      } else {
+        Parent::changeSource(e,n);
+      }
     }
     /// \brief Contract two nodes.
@@ -1304,8 +1314,8 @@
         if (r && runningNode(e) == a) {
           erase(e);
-        } else if (u(e) == b) {
-          changeU(e, a);
+        } else if (source(e) == b) {
+          changeSource(e, a);
         } else {
-          changeV(e, a);
+          changeTarget(e, a);
         }
         e = f;
